
global MAIN_DICT_s10_10g_kr_0
dict set MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR 0x0800
dict set MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO 0x0000

proc dashboard_s10_10g_kr_0 {} {
	global dash_s10_10g_kr_0
	global MAIN_DICT_s10_10g_kr_0
	
	set dash_s10_10g_kr_0 [add_service dashboard Ethernet_Link_Monitor_s10_10g_kr_0 "Ethernet Link Monitor" "Tools/Ethernet_Link_Monitor_s10_10g_kr_0"]
	dashboard_set_property $dash_s10_10g_kr_0 self visible true
	widget_group topGroup self 1 ""
	
		widget_label ip_var topGroup "IP Variant: Stratix 10 10GBASE-KR PHY IP"
		widget_checkBox continuous_read topGroup "Continuous Read All Registers" proc_continuous_read
	
		dashboard_add $dash_s10_10g_kr_0 allstatus tabbedGroup topGroup
	
			#
			#PHY - KR
			#
			widget_group KR4 allstatus 1 "KR"
			
				widget_button read_kr4_status KR4 "Read KR Status" proc_read_kr4_status
				
				widget_group kr4_dummy_1 KR4 3 ""
		
				#
				#Sequencer
				#
				widget_group SEQ kr4_dummy_1 3 "Sequencer"
					
					widget_button reset_seq SEQ "Reset Sequencer"  proc_reset_seq
					widget_label  seq_blank_1 SEQ ""
					widget_label  seq_blank_2 SEQ ""
		
					widget_label  seq_force SEQ "SEQ Force Mode"
					widget_comboBox seq_force_mode SEQ {"No Force" "10GBASE-R" "10GBASE-KR"  "10GBASE-KR FEC"}
					widget_button seq_force SEQ "Force" proc_seq_force
					
					widget_label SEQ_LNK_RDY SEQ "SEQ Link Ready"
					widget_led SEQ_LNK_RDY_LED SEQ ""  black
					widget_label  seq_blank_3 SEQ ""
		
					widget_label SEQ_MODE SEQ "SEQ Mode"
					widget_label SEQ_RECONFG_MODE SEQ ""
					widget_label  seq_blank_3 SEQ ""
		
				#
				# Auto Negotiation & FEC Parameters
				#
				widget_group AN_FEC kr4_dummy_1 7 "Auto Negotiation & FEC"
				
					widget_group AN AN_FEC 2 "AN"
						widget_label an_ena_title AN "AN Enable"
						widget_led an_ena_data AN ""  black
						widget_label an_comp_title AN "AN Complete"
						widget_label an_comp_data AN ""
						widget_label an_abi_title AN "AN Ability"
						widget_label an_abi_data AN ""
						widget_label an_stat_title AN "AN Status"
						widget_led	an_stat_data AN ""  black
						#widget_label lp_an_abi_title AN "LP AN Ability"
						#widget_label lp_an_abi_data AN ""
						widget_label seq_an_title AN "SEQ AN"
						widget_label seq_an_data AN ""
						widget_label fi_an_title AN "Final AN Tech"
						widget_label	fi_an_data AN ""
						#widget_label lp_an_title AN "LP AN Tech"
						#widget_text	lp_an_data AN ""
					
					widget_group FEC AN_FEC 2 "FEC"
					
						widget_label fec_ena_title FEC "FEC Enable"
						widget_led	fec_ena_data FEC ""  black
						
						widget_label fec_req_title FEC "FEC Request Enable"
						widget_led fec_req_data FEC ""  black
						
						#widget_label fec_abi_title FEC "FEC ability"
						#widget_led	fec_abi_data FEC ""  black
						
				#
				# Link Training Parameters
				#
				widget_group LT KR4 2 "Link Training"
				
					widget_label lt_ena_title LT "LT Enable"
					widget_led lt_ena_data LT ""  black
							
					widget_label conv_tx_title LT "Converged TX (vod, post, pre)"
					widget_label conv_tx_l0 LT "0, 0, 0"
					
					widget_label conv_vga_title LT "Converged VGA"
					widget_label conv_vga_l0 LT "0"
					
					widget_label conv_ctledc_title LT "Converged CTLE DC"
					widget_label conv_ctledc_l0 LT "0"
										
					widget_label conv_ctleac_title LT "Converged CTLE AC"
					widget_label conv_ctleac_l0 LT "0"
					
					widget_label conv_dfe_title LT "Converged DFE"
					widget_label conv_dfe_l0 LT "0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0"
						
}

proc widget_group {name group itemsPerRow text} {
	global dash_s10_10g_kr_0
	dashboard_add $dash_s10_10g_kr_0 $name group $group
	dashboard_set_property $dash_s10_10g_kr_0 $name itemsPerRow $itemsPerRow
	dashboard_set_property $dash_s10_10g_kr_0 $name title $text
}

proc widget_checkBox {name group text onClick} {
	global dash_s10_10g_kr_0
	dashboard_add $dash_s10_10g_kr_0 $name checkBox $group
	dashboard_set_property $dash_s10_10g_kr_0 $name text $text
	dashboard_set_property $dash_s10_10g_kr_0 $name onClick $onClick
}

proc widget_button {name group text onClick} {
	global dash_s10_10g_kr_0
	dashboard_add $dash_s10_10g_kr_0 $name button $group
	dashboard_set_property $dash_s10_10g_kr_0 $name text $text
	dashboard_set_property $dash_s10_10g_kr_0 $name onClick $onClick
}

proc widget_label {name group text} {
	global dash_s10_10g_kr_0
	dashboard_add $dash_s10_10g_kr_0 $name label $group
	dashboard_set_property $dash_s10_10g_kr_0 $name text $text
}

proc widget_led {name group text color} {
	global dash_s10_10g_kr_0
	dashboard_add $dash_s10_10g_kr_0 $name led $group
	dashboard_set_property $dash_s10_10g_kr_0 $name text $text
	dashboard_set_property $dash_s10_10g_kr_0 $name color $color
}

proc widget_text {name group text} {
	global dash_s10_10g_kr_0
	dashboard_add $dash_s10_10g_kr_0 $name text $group
	dashboard_set_property $dash_s10_10g_kr_0 $name text $text
}

proc widget_comboBox {name group options} {
	global dash_s10_10g_kr_0
	dashboard_add $dash_s10_10g_kr_0 $name comboBox $group
	dashboard_set_property $dash_s10_10g_kr_0 $name options $options
}

proc proc_continuous_read {} {
	global dash_s10_10g_kr_0
	global MAIN_DICT_s10_10g_kr_0
	
	while {[string match [dashboard_get_property $dash_s10_10g_kr_0 continuous_read checked] "true"]} {
	proc_read_kr4_status
	}
}

proc proc_read_kr4_status {} {
	global dash_s10_10g_kr_0
	global MAIN_DICT_s10_10g_kr_0
	
	proc_read_kr4_status_1
	after 50
	proc_read_kr4_status_1
	
}	

proc proc_read_kr4_status_1 {} {
	global dash_s10_10g_kr_0
	global MAIN_DICT_s10_10g_kr_0
	
	set DATA_KR_04B0 [reg_read [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR]]
	puts "0x04B0 $DATA_KR_04B0"
		if {[expr $DATA_KR_04B0 & 0x00010000]} {
             dashboard_set_property $dash_s10_10g_kr_0 fec_ena_data color "green"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 fec_ena_data color "red"
           }
		if {[expr $DATA_KR_04B0 & 0x00040000]} {
             dashboard_set_property $dash_s10_10g_kr_0 fec_req_data color "green"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 fec_req_data color "red"
           }
	
	set DATA_KR_04B1 [reg_read [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B1] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR] ]
	puts "0x04B1 $DATA_KR_04B1"
	    if {[expr $DATA_KR_04B1 & 0x00000001]} {
             dashboard_set_property $dash_s10_10g_kr_0 SEQ_LNK_RDY_LED color "green"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 SEQ_LNK_RDY_LED color "red"
           }
		
		if {[expr $DATA_KR_04B1 & 0x00000100]} {
             dashboard_set_property $dash_s10_10g_kr_0 SEQ_RECONFG_MODE text "AN mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00000200]} {
             dashboard_set_property $dash_s10_10g_kr_0 SEQ_RECONFG_MODE text "LT mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00000400]} {
             dashboard_set_property $dash_s10_10g_kr_0 SEQ_RECONFG_MODE text "10G Data Mode"
           } elseif {[expr $DATA_KR_04B1 & 0x00002000]} {
             dashboard_set_property $dash_s10_10g_kr_0 SEQ_RECONFG_MODE text "10G FEC Mode"
           } else {
		   dashboard_set_property $dash_s10_10g_kr_0 SEQ_RECONFG_MODE text ""
           }
		   
	set DATA_KR_04C0 [reg_read [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR]]
	puts "0x04C0 $DATA_KR_04C0"
	    if {[expr $DATA_KR_04C0 & 0x00000001]} {
             dashboard_set_property $dash_s10_10g_kr_0 an_ena_data color "green"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 an_ena_data color "red"
           }
		   
	set DATA_KR_04C2 [reg_read [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C2] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR]]
	puts "0x04C2 $DATA_KR_04C2"
	    if {[expr $DATA_KR_04C2 & 0x00000004]} {
             dashboard_set_property $dash_s10_10g_kr_0 an_comp_data text "Complete"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 an_comp_data text "In Progress"
           }
		   
		if {[expr $DATA_KR_04C2 & 0x00000020]} {
             dashboard_set_property $dash_s10_10g_kr_0 an_abi_data text "Able to perform AN"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 an_abi_data text "Unable to perform AN"
           }
		   
	    if {[expr $DATA_KR_04C2 & 0x00000040]} {
             dashboard_set_property $dash_s10_10g_kr_0 an_stat_data color "green"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 an_stat_data color "red"
           }
		   
		if {[expr $DATA_KR_04C2 & 0x00000200]} {
             dashboard_set_property $dash_s10_10g_kr_0 seq_an_data text "Failure detected"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 seq_an_data text "Failure not detected"
           }
		   
		if {[expr $DATA_KR_04C2 & 0x00001000]} {
             dashboard_set_property $dash_s10_10g_kr_0 fi_an_data text "1000BASE-KX"
           } elseif {[expr $DATA_KR_04C2 & 0x00002000]} {
             dashboard_set_property $dash_s10_10g_kr_0 fi_an_data text "10GBASE-KX4"
           } elseif {[expr $DATA_KR_04C2 & 0x00004000]} {
             dashboard_set_property $dash_s10_10g_kr_0 fi_an_data text "10GBASE-KR"
           } elseif {[expr $DATA_KR_04C2 & 0x00008000]} {
             dashboard_set_property $dash_s10_10g_kr_0 fi_an_data text "40GBASE-KR4"
           } elseif {[expr $DATA_KR_04C2 & 0x00010000]} {
             dashboard_set_property $dash_s10_10g_kr_0 fi_an_data text "40GBASE-CR4"
           } elseif {[expr $DATA_KR_04C2 & 0x00020000]} {
             dashboard_set_property $dash_s10_10g_kr_0 fi_an_data text "100GBASE-CR10"
           } else {
			 dashboard_set_property $dash_s10_10g_kr_0 fi_an_data text ""
		   }

	proc_lt_all_status
	
}

proc proc_lt_all_status {} {
	global dash_s10_10g_kr_0
	global MAIN_DICT_s10_10g_kr_0
	
	set DATA_KR_04D0 [reg_read [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04D0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR] ]
	puts "0x04D0 $DATA_KR_04D0"
	    if {[expr $DATA_KR_04D0 & 0x00000001]} {
             dashboard_set_property $dash_s10_10g_kr_0 lt_ena_data color "green"
           } else {
             dashboard_set_property $dash_s10_10g_kr_0 lt_ena_data color "red"
           }
	
	proc_lt_status {0}

}

proc proc_lt_status {chan} {
	global dash_s10_10g_kr_0
	global MAIN_DICT_s10_10g_kr_0
	
	#set chan 0
	
	set vod [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_VOD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]]
	set vod [expr $vod & 0x1f]
	
	set post [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_POST] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]]
	if {$post & 0x40} {
        set post [expr -($post & 0x3f)]
    } else {
        set post [expr $post & 0x3f]
    }
	
	set pre [reconfig_reg_read $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_PRE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]]
    if {$pre & 0x20} {
        set pre [expr -($pre & 0x1f)]
    } else {
        set pre [expr $pre & 0x1f]
    }
	dashboard_set_property $dash_s10_10g_kr_0 conv_tx_l$chan text "$vod, $post, $pre"
	
	#  Test bus = ADP 171[4:1]=1
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPBLOCK] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x1E 0x16
    
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 5
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
	set vga [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x1F]
	dashboard_set_property $dash_s10_10g_kr_0 conv_vga_l$chan text "$vga"
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 4
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    set ctle_dc [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x3F]
	dashboard_set_property $dash_s10_10g_kr_0 conv_ctledc_l$chan text "$ctle_dc"
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 3
	reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    set ctle_ac [expr [expr [ reconfig_reg_read $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] >> 3] & 0xF]
	dashboard_set_property $dash_s10_10g_kr_0 conv_ctleac_l$chan text "$ctle_ac"
	
	#  Test bus = ADP 171[4:1]=1
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPBLOCK] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x1E 0x16
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 7
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    set tap1 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x7F]
    if {$tap1 & 0x40} {
        set tap1 [expr -($tap1 & 0x3f)]
    } else {
        set tap1 [expr $tap1 & 0x3f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 8
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    set tap2 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x3F]
    if {$tap2 & 0x20} {
         set tap2 [expr -($tap2 & 0x1f)]
    } else {
       
		set tap2 [expr $tap2 & 0x1f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 9
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    set tap3 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x3F]
    if {$tap3 & 0x20} {
        
		set tap3 [expr -($tap3 & 0x1f)]
    } else {
        set tap3 [expr $tap3 & 0x1f]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 10
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    set tap4 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap4 & 0x10} {
        set tap4 [expr -($tap4 & 0xf)]
    } else {
        
		set tap4 [expr $tap4 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 11
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    set tap5 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap5 & 0x10} {
         set tap5 [expr -($tap5 & 0xf)]
    } else {
       
		set tap5 [expr $tap5 & 0xf]
    }
   
    reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 12
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
    set tap6 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x1F]
    if {$tap6 & 0x10} {
        set tap6 [expr -($tap6 & 0xf)]
    } else {
        
		set tap6 [expr $tap6 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 13
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
	set tap7 [expr [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]] & 0x1F]
	if {$tap7 & 0x10} {
        set tap7 [expr -($tap7 & 0xf)]
    } else {
        
		set tap7 [expr $tap7 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 14
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
	set tap8_tap9 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]]
	set tap8 [expr $tap8_tap9 & 0xF]
	if {$tap7 & 0x10} {
        set tap8 [expr -($tap8 & 0xf)]
    } else {
        
		set tap8 [expr $tap8 & 0xf]
    }
	set tap9 [expr [expr $tap8_tap9 >> 4] & 0xF]
	if {$tap9 & 0x10} {
        set tap9 [expr -($tap9 & 0xf)]
    } else {
        
		set tap9 [expr $tap9 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 15
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
	set tap10_tap11 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]]
	set tap10 [expr $tap10_tap11 & 0xF]
	if {$tap10 & 0x10} {
        set tap10 [expr -($tap10 & 0xf)]
    } else {
        
		set tap10 [expr $tap10 & 0xf]
    }
	set tap11 [expr [expr $tap10_tap11 >> 4] & 0xF]
	if {$tap11 & 0x10} {
        set tap11 [expr -($tap11 & 0xf)]
    } else {
        
		set tap11 [expr $tap11 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 16
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
	set tap12_tap13 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]]
	set tap12 [expr $tap12_tap13 & 0xF]
	if {$tap12 & 0x10} {
        set tap12 [expr -($tap12 & 0xf)]
    } else {
        
		set tap12 [expr $tap12 & 0xf]
    }
	set tap13 [expr [expr $tap12_tap13 >> 4] & 0xF]
	if {$tap13 & 0x10} {
        set tap13 [expr -($tap13 & 0xf)]
    } else {
        
		set tap13 [expr $tap13 & 0xf]
    }
	
	reconfig_reg_rmw $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0x3F 17
    reconfig_reg_write $chan [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO] 0
	set tap14_tap15 [reconfig_reg_read $chan   [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10RECO]]
	set tap14 [expr $tap14_tap15 & 0xF]
	if {$tap14 & 0x10} {
        set tap14 [expr -($tap14 & 0xf)]
    } else {
        
		set tap14 [expr $tap14 & 0xf]
    }
	set tap15 [expr [expr $tap14_tap15 >> 4] & 0xF]
	if {$tap15 & 0x10} {
        set tap15 [expr -($tap15 & 0xf)]
    } else {
        
		set tap15 [expr $tap15 & 0xf]
    }
	
	dashboard_set_property $dash_s10_10g_kr_0 conv_dfe_l$chan text "$tap1, $tap2, $tap3, $tap4, $tap5, $tap6, $tap7, $tap8, $tap9, $tap10, $tap11, $tap12, $tap13, $tap14, $tap15"
}

proc proc_reset_seq {} {
	global dash_s10_10g_kr_0
	global MAIN_DICT_s10_10g_kr_0
	
	#reconfig_reg_rmw {chan addr offset mask val}
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR] 0x1 0x1

}

proc proc_seq_force {} {
	global dash_s10_10g_kr_0
	global MAIN_DICT_s10_10g_kr_0
	global val
	
	if {[string match [dashboard_get_property $dash_s10_10g_kr_0 seq_force_mode options] "No Force"]} {
	#set val 0x01
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR] 0x01 0x01
	} elseif {[string match [dashboard_get_property $dash_s10_10g_kr_0 seq_force_mode options] "10GBASE-R"]} {
	#set val 0x41
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR] 0x000000f1 0x41
	} elseif {[string match [dashboard_get_property $dash_s10_10g_kr_0 seq_force_mode options] "10GBASE-KR"]} {
	#set val 0x51
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR] 0x000000f1 0x51
	} elseif {[string match [dashboard_get_property $dash_s10_10g_kr_0 seq_force_mode options] "10GBASE-KR FEC"]} {
	#set val 0xc1
	reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR] 0x000000f1 0xc1
	}

	#reconfig_reg_rmw {chan addr offset mask val}
	#reconfig_reg_rmw 0 [dict get $MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B0] [dict get $MAIN_DICT_s10_10g_kr_0 OFFSET_S10CSR] 0xffffff0e $val

}

# ================================================================== 
# 	XCVR RECONFIG
# ==================================================================
dict set MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPBLOCK 0x171
dict set MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPWRITE 0x149
dict set MAIN_DICT_s10_10g_kr_0 ADDR_LT_ADAPREAD 0x17E
dict set MAIN_DICT_s10_10g_kr_0 ADDR_LT_VOD 0x109
dict set MAIN_DICT_s10_10g_kr_0 ADDR_LT_POST 0x105
dict set MAIN_DICT_s10_10g_kr_0 ADDR_LT_PRE 0x107

# ================================================================== 
# 	General 40GBASE-KR4/CR4 Registers
# ==================================================================
#
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B0	0x04B0
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B1	0x04B1
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04B2	0x04B2

# ================================================================== 
# 	Auto-negotiation Registers
# ==================================================================
#
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C0	0x04C0
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C1	0x04C1
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C2	0x04C2
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C3	0x04C3
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C4	0x04C4
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C5	0x04C5
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C6	0x04C6
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C7	0x04C7
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C8	0x04C8
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04C9	0x04C9
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04CA	0x04CA
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04CB	0x04CB

# ================================================================== 
# 	Link training Registers
# ==================================================================
#
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04D0	0x04D0
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04D1	0x04D1
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04D2	0x04D2
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04D3	0x04D3
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04D4	0x04D4
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04D5	0x04D5
dict set MAIN_DICT_s10_10g_kr_0 ADDR_KR_04D6	0x04D6
